/*
 * Created on 06.07.2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package diplom;

import java.io.FileInputStream;

/**
 * @author alexander.boltkov
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PSNR {
	
	private String fileNameIn = "C:/-/psnr/400_mono.wav";	
	private String fileNameOut = "C:/-/psnr/FEC_400_errors.wav";
	
	private final static int BUFFER_SIZE = 128;

	/**
	 * 
	 */
	public PSNR(String fileIn, String fileOut) {
		super();	
		fileNameIn = fileIn;
		fileNameOut = fileOut;
		start();
		
	}
	
	/**
	 * 
	 */
	public  void start() {
		
		double mse = 0;
		double psnr = 0;
		
		try {
			FileInputStream fileIn = new FileInputStream(fileNameIn);				
			FileInputStream fileOut = new FileInputStream(fileNameOut);
			
			byte bufIn[] = new byte[BUFFER_SIZE];
			byte bufOut[] = new byte[BUFFER_SIZE];
            int lenIn, lenOut; 
            int sumSize = 0;
            
            while ((lenIn = fileIn.read(bufIn,0,bufIn.length)) > 0) {
            	if ((lenOut = fileOut.read(bufOut,0,lenIn)) > 0) {
            		
            		// Mse berechnen
            		mse += getMSE(bufIn, bufOut);
            		sumSize += bufIn.length;

            	}
            }
            
            mse = mse / sumSize;
            
            // PSNR berechnen
            psnr = getPSNR(mse);
            
            System.out.println("File: "+fileNameOut+" PSNR: "+psnr);
             
		} catch (Exception e) {
			e.printStackTrace();
		}	
		
	}

	/**
	 * @param bufIn
	 * @param bufOut
	 * @return
	 */
	private static double getMSE(byte[] bufIn, byte[] bufOut) {
		
		double mse = 0;
		
		
		// Summe
		for (int i = 0; i < bufIn.length-1; i++) {
			mse += (bufIn[i] - bufOut[i])*(bufIn[i] - bufOut[i]);
			
		}
		
		return mse;
	}
	
	/**
	 * @param b1
	 * @param b2
	 * @return
	 */
	private static Integer byte2int(byte b1, byte b2) {
		int value = 0;
		int schift = (2-1-0)*8;
		value += (b1 & 0x000000FF) << schift;
		schift = (2-1-1)*8;
		value += (b2 & 0x000000FF) << schift;
		
		return new Integer(value);
	}

	/**
	 * @param mse
	 * @return
	 */
	private static double getPSNR(double mse) {
		double psnr = 0;
		double maxI = 65535;
		
		psnr = 10 * Math.log10(maxI*maxI/mse);
		
		return psnr;
	}
		
}
